//====================================================================================================
// Project:	WebOS
// Version:	0.1 Alpha
//
// Scriptname:	Panel
// Version:	0.1 Alpha
//
// Copyright:	PN-Solution
// Homepage:	http://www.pn-solution.de/
// E-Mail:	admin@pn-solution.de
//		support@pn-solution.de
//====================================================================================================

//====================================================================================================
// Panel - Varibalen
//====================================================================================================

var panel = new panel;

var panel_height;
var panel_width;

var time = document.createTextNode('Zeit');
var date = document.createTextNode('Datum');

//====================================================================================================
// Panel
//====================================================================================================
function panel() {
	this.init = init;
	this.uhrzeit = uhrzeit;
	
	//====================================================================================================
	// Init
	//====================================================================================================
	function init() {

		panel_height = '48';
		panel_width = '650';

		var objects = new Object();
		objects.desktop = document.getElementById('desktop');

		objects.panel = document.createElement('div');

		//Icons/Menu
		objects.table = document.createElement('table');
		objects.tbody = document.createElement('tbody');
		objects.tr = document.createElement('tr');

		objects.td = new Array();

		//table.setAttribute('cellpadding','2');
		objects.table.setAttribute('cellspacing','0');
		objects.table.setAttribute('border','0');

		objects.table.style.borderCollapse = 'collapse';
		objects.table.style.border = '0px none transparent';

		objects.table.setAttribute('height','48');

		for(i=0; i<6; i++) {
			objects.td[i] = document.createElement('td');

			objects.td[i].style.paddingRight = 2;
			objects.td[i].style.paddingLeft = 2;

			objects.td[i].style.paddingTop = 0;
			objects.td[i].style.paddingBottom = 0;

		}

		objects.icon_menu = document.createElement('img');
		objects.icon_home = document.createElement('img');
		objects.icon_terminal = document.createElement('img');
		objects.icon_settings = document.createElement('img');
		objects.icon_software = document.createElement('img');
		objects.icon_appstarter = document.createElement('img');

		objects.virtual_desktop = new Array();
		objects.textnode = new Array();

		objects.td[0].appendChild(objects.icon_menu);
		objects.td[1].appendChild(objects.icon_home);
		objects.td[2].appendChild(objects.icon_terminal);
		objects.td[3].appendChild(objects.icon_settings);
		objects.td[4].appendChild(objects.icon_software);
		objects.td[5].appendChild(objects.icon_appstarter);

		//Virtual Desktop's
		objects.table_vd = document.createElement('table');
		objects.tbody_vd = document.createElement('tbody');
		objects.tr_vd = document.createElement('tr');

		objects.td_vd = new Array();

		objects.table_vd.setAttribute('cellpadding','0');
		objects.table_vd.setAttribute('cellspacing','0');

		objects.table_vd.style.borderCollapse = 'collapse';

		objects.table_vd.setAttribute('height','44');

		for(i=1; i<5; i++) {
			objects.virtual_desktop[i] = document.createElement('div');
			objects.virtual_desktop[i].setAttribute('onclick','virtualdesktop.switch_desktop(' + i + ');');
			objects.virtual_desktop[i].setAttribute('height','46');
			objects.virtual_desktop[i].setAttribute('width','46');

			objects.virtual_desktop[i].style.height = 44;
			objects.virtual_desktop[i].style.width = 44;

			objects.virtual_desktop[i].setAttribute('class','virtual_desktop');
			objects.virtual_desktop[i].setAttribute('id','virtual_desktop' + i);

			objects.virtual_desktop[i].setAttribute('position','static');

			objects.td_vd[objects.td_vd.length] = document.createElement('td');

			objects.td_vd[objects.td_vd.length-1].appendChild(objects.virtual_desktop[i]);

		}

		for(i=0; i<objects.td_vd.length; i++) {
			objects.td_vd[i].setAttribute('align','center');
			objects.td_vd[i].setAttribute('valign','middle');

			objects.tr_vd.appendChild(objects.td_vd[i]);
		}

		objects.td[objects.td.length] = document.createElement('td');
		objects.td[objects.td.length-1].appendChild(objects.table_vd);

		//Panel
		objects.panel.setAttribute('class','panel');
		objects.panel.setAttribute('id','panel');

		objects.panel.style.verticalAlign = 'middle';

		//panel.style.width = panel_width + 'px';
		objects.panel.style.height = panel_height + 'px';

		//Icons
		objects.icon_menu.setAttribute('src','system/icons/default/32x32/panel/penguin.png');
		objects.icon_home.setAttribute('src','system/icons/default/32x32/panel/home.png');
		objects.icon_terminal.setAttribute('src','system/icons/default/32x32/panel/terminal.png');
		objects.icon_settings.setAttribute('src','system/icons/default/32x32/panel/settings.png');
		objects.icon_software.setAttribute('src','system/icons/default/32x32/panel/software.png');
		objects.icon_appstarter.setAttribute('src','system/icons/default/32x32/panel/appstarter.png');

		objects.icon_menu.setAttribute('alt','webOS Hauptmenü');
		objects.icon_home.setAttribute('alt','Home Verzeichnis');
		objects.icon_terminal.setAttribute('alt','Terminal');
		objects.icon_settings.setAttribute('alt','Einstellungen');
		objects.icon_software.setAttribute('alt','Software Installieren und Deinstallieren');
		objects.icon_appstarter.setAttribute('alt','Programmstarten');

		objects.icon_menu.setAttribute('id','icon_menu');
		objects.icon_home.setAttribute('id','icon_home');
		objects.icon_terminal.setAttribute('id','icon_terminal');
		objects.icon_settings.setAttribute('id','icon_settings');
		objects.icon_software.setAttribute('id','icon_software');
		objects.icon_appstarter.setAttribute('id','icon_appstarter');

		objects.icon_menu.setAttribute('onclick','mainmenu.show(event);');
		objects.icon_home.setAttribute('onclick','none();');
		objects.icon_terminal.setAttribute('onclick','none();');
		objects.icon_settings.setAttribute('onclick','none();');
		objects.icon_software.setAttribute('onclick','none();');
		objects.icon_appstarter.setAttribute('onclick','taskmanager.create(\'appstarter\');');

		//Uhrzeit
		objects.zeit = document.createElement('div');
		objects.datum = document.createElement('div');

		objects.zeit.setAttribute('id','time');
		objects.datum.setAttribute('id','date');

		objects.zeit.setAttribute('class','time');
		objects.datum.setAttribute('class','date');

		objects.zeit.appendChild(time);
		objects.datum.appendChild(date);

		objects.td[objects.td.length] = document.createElement('td');
		objects.td[objects.td.length-1].appendChild(objects.zeit);
		objects.td[objects.td.length-1].appendChild(objects.datum);

		for(i=0; i<objects.td.length; i++) {
			objects.td[i].setAttribute('align','center');
			objects.td[i].setAttribute('valign','middle');

			objects.tr.appendChild(objects.td[i]);
		}

		objects.tbody.appendChild(objects.tr);
		objects.table.appendChild(objects.tbody);

		objects.tbody_vd.appendChild(objects.tr_vd);
		objects.table_vd.appendChild(objects.tbody_vd);

		objects.panel.appendChild(objects.table);

		objects.desktop.appendChild(objects.panel);

		panel.uhrzeit();

		//Panel position setzen
		gui.desktop.height = parseInt(gui.desktop.height);
		gui.desktop.width = parseInt(gui.desktop.width);

		objects.panel.style.left = (gui.desktop.width / 2) - (parseInt(objects.panel.offsetWidth) / 2);
		objects.panel.style.top = gui.desktop.height - parseInt(objects.panel.offsetHeight) + 2;

		if(gui.panel.opacity!='no') {
			effects.opacity('panel', gui.panel.opacity);
		}
	}

	//====================================================================================================
	// Uhrzeit
	//====================================================================================================v
	function uhrzeit() {

		var Datum = new (Date);
	
		//Datum
		var Tag = Datum.getDate();
		var Wochentag = Datum.getDay();
		var Monat = Datum.getMonth();
		var Jahr = Datum.getFullYear();

		//Uhrzeit
		var Stunde = Datum.getHours();
		var Minute = Datum.getMinutes();
		var Sekunden = Datum.getSeconds();

		var Tagname = new Array('Sonntag','Montag','Dienstag','Mittwoh','Donnerstag','Freitag','Samstag');

		if(Sekunden < 10) {
			Sekunden = '0' + Sekunden;
		}

		if(Minute < 10) {
			Minute = '0' + Minute;
		}

		if(Stunde < 10) {
			Stunde = '0' + Stunde;
		}

		time.data = Stunde + ':' + Minute + ':' + Sekunden;
		date.data = Tagname[Wochentag] + ' - ' + Tag + '.' + Monat + '.' + Jahr;

		setTimeout('panel.uhrzeit();', 1000);
	}
}