//====================================================================================================
// Project:	WebOS
// Version:	0.1 Alpha
//
// Scriptname:	Window Manager
// Version:	0.1 Alpha
//
// Copyright:	PN-Solution
// Homepage:	http://www.pn-solution.de/
// E-Mail:	admin@pn-solution.de
//		support@pn-solution.de
//====================================================================================================

//====================================================================================================
// Hauptvaribalen
//====================================================================================================
var window_manager = new window_manager;

var windowID = 0;
var ganzoben;

var active_window;

//====================================================================================================
// Window infromation in mehreren Arrays
//====================================================================================================
var window_task_id = new Array();

var window_left = new Array();
var window_top = new Array();

var window_height = new Array();
var window_width = new Array();

var window_min = new Array();
var window_max = new Array();

var window_move = new Array();
var window_resize = new Array();

var window_virt_desk = new Array();

var window_titel = new Array();

var window_caption = new Array();
var window_icon = new Array();

//====================================================================================================
// drag & drop
//====================================================================================================
var WID; //FensterID zum verschieben

var window_startX;
var window_startY;

var window_Xalt;
var window_Yalt;

var window_width_alt;
var window_height_alt;

var window_left_alt;
var window_top_alt;

//====================================================================================================
// Globale Variablen für move, resize, create
//====================================================================================================
var bwindow_move;
var bwindow_resize;
var bwindow_create;

//====================================================================================================
// Window Manager
//====================================================================================================
function window_manager() {
	this.init = init;
	this.xwindow = new xwindow;

	this.mouse = new mouse;

	this.check = new check;

	this.iframe_hide = iframe_hide;

	//====================================================================================================
	// Init
	//====================================================================================================
	function init() {
		bwindow_move = false;
		bwindow_resize = false;
		bwindow_create = false;
	}

	//====================================================================================================
	// Window
	//====================================================================================================
	function xwindow() {
		this.create = create;
		this.remove = remove;

		this.move = new move;
		this.resize = new resize;

		this.activate = activate;

		this.check = new check;


		//====================================================================================================
		//Window - Create
		//====================================================================================================
		function create(sAppSrc, sFrmSrc) {

			windowID++;

			var iTop=0;
			var iLeft=0;

			var iWidth=200;
			var iHeight=200;

			var bmin=true;
			var bmax=true;

			var bclose=true;

			var bresize=true;
			var bmove=true;

			var sScrolling='auto';

			var sIcon='default.png';
			var sName='Unknown';

			var bmdi = false;

			//Config Laden
			var xmlhttp = new xmlhttpRequest.create();

			xmlhttp.open( 'GET', 'apps/' + sAppSrc + '.app/' + sFrmSrc + '.frm/'  + sFrmSrc + '.conf', false);
			xmlhttp.send(null);

			var Puffer = xmlhttp.responseText;

			var tmp = new Array();
			var tmp2 = new Array();

			tmp = Puffer.split('\n');

			for(i=0 ; i<tmp.length ; i++) {
				tmp2 = tmp[i].split('=');

				switch(tmp2[0]) {
					case 'top':
						iTop=tmp2[1];
						break;
					case 'left':
						iLeft=tmp2[1];
						break;
					case 'width':
						iWidth=tmp2[1];
						break;
					case 'height':
						iHeight=tmp2[1];
						break;
					case 'min':
						switch(tmp2[1]) {
							case 'true':
								bmin=true;
								break;
							case 'false':
								bmin=false;
								break;
						}
						break;
					case 'max':
						switch(tmp2[1]) {
							case 'true':
								bmax=true;
								break;
							case 'false':
								bmax=false;
								break;
					}
						break;
					case 'close':
						switch(tmp2[1]) {
							case 'true':
								bclose=true;
								break;
							case 'false':
								bclose=false;
								break;
						}
						break;
					case 'resize':
						switch(tmp2[1]) {
							case 'true':
								bresize=true;
								break;
							case 'false':
								bresize=false;
								break;
						}
						break;
					case 'move':
						switch(tmp2[1]) {
							case 'true':
								bmove=true;
								break;
							case 'false':
								bmove=false;
								break;
						}
						break;
					case 'caption':
						sCaption=tmp2[1];
						break;
					case 'icon':
						sIcon=tmp2[1];
						break;
					case 'scrolling':
						sScrolling=tmp2[1]
						break;
					case 'mdi':
						switch(tmp2[1]) {
							case 'true':
								bmdi=true;
								break;
							case 'false':
								bmdi=false;
								break;
						}
						break;

				}
			}

			//Wenn die Varibalen keine Nummer ist
			if(isNaN(iTop)) {
				iTop=0;
			}

			if(isNaN(iLeft)) {
				iLeft=0;
			}

			if(isNaN(iWidth)) {
				iWidth=200;
			}

			if(isNaN(iHeight)) {
				iHeight=100;
			}

			//wenn nicht true und nicht false
			if(bmin!=true && bmin!=false) {
				bmin=true;
			}

			if(bmax!=true && bmax!=false) {
				bmax=true;
			}

			if(bclose!=true && bclose!=false) {
				bclose=true;
			}

			if(bmove!=true && bmove!=false) {
				bmove=true;
			}

			if(bresize!=true && bresize!=false) {
				bresize=true;
			}

			if(bmdi!=true && bmdi!=false) {
				bmdi=false;
			}

			if(sScrolling!='yes' && sScrolling!='no' && sScrolling!='auto') {
				sScrolling='auto';
			}

			//Wenn kein Programmpfad übermittelt wurde
			if(sAppSrc=='') {
				Alert('WARNUNG! Es wurde kein Programmpfad übermittelt!');

				sAppSrc='error';
			}

			//Varibalen für das Fenster erstellen und zuweisen
			var new_window = new Object();
			var system = new Object();

			desktop = document.getElementById('desktop');

			var xwindow = document.createElement('div');

			var xwindow3 = document.createElement('div');
			var xwindow4 = document.createElement('div');
			var xwindow5 = document.createElement('div');
			var xwindow6 = document.createElement('div');
			var xwindow7 = document.createElement('div');
			var xwindow8 = document.createElement('div');

			var table = document.createElement('table');
			var tbody = document.createElement('tbody');

			var tr = new Array(3);
			var td = new Array(9);

			var textnode = document.createTextNode('WID: ' + windowID + ' ' + sCaption);
			var titelbar = document.createElement('div');

			titelbar.setAttribute('class','titelbar');
			titelbar.setAttribute('id','titelbar' + windowID);

			xwindow3.setAttribute('class','xwindow3');
			xwindow3.setAttribute('id','xwindow3_' + windowID);

			xwindow4.setAttribute('class','xwindow4');
			xwindow4.setAttribute('id','xwindow4_' + windowID);

			xwindow4.setAttribute('width','100%');
			xwindow4.setAttribute('height','100%');

			xwindow4.style.width = '100%';
			xwindow4.style.height = '100%';

			xwindow5.setAttribute('class','xwindow5');
			xwindow5.setAttribute('id','xwindow5_' + windowID);

			xwindow6.setAttribute('class','xwindow6');
			xwindow6.setAttribute('id','xwindow6_' + windowID);

			xwindow7.setAttribute('class','xwindow7');
			xwindow7.setAttribute('id','xwindow7_' + windowID);

			xwindow8.setAttribute('class','xwindow8');
			xwindow8.setAttribute('id','xwindow8_' + windowID);

			var iframe = document.createElement('iframe');

			iframe.setAttribute('class','iframe');

			iframe.setAttribute('id','iframe' + windowID);

			iframe.setAttribute('width','100%');
			iframe.setAttribute('height','100%');

			iframe.style.width = '100%';
			iframe.style.height = '100%';

			iframe.src = 'apps/apps.php?app=' + sAppSrc + '&frm=' + sFrmSrc + '&mdi=' + bmdi + '&wid=' + windowID + '&tid=' + taskID + '&template=default';
			iframe.setAttribute('scrolling', sScrolling);

			var i = 0;

			for(i=0 ; i<3 ; i++) {
				tr[i] = document.createElement('tr');
			}

			for(i=0 ; i<9 ; i++) {
				td[i] = document.createElement('td'); //Elemtene erstellen und Array zuweisen
				td[i].setAttribute('class','xwindow' + i); //class setzen
				td[i].setAttribute('id','xwindow_td' + i + '_' + windowID); //id setzen
			}

			//Min Button
			var button_min = document.createElement('div');
			button_min.setAttribute('id','min' + windowID);

			if (bmin==true) {
				button_min.setAttribute('class','min');
			} else {
				button_min.setAttribute('class','min-disabled');
			}

			xwindow.appendChild(button_min);

			//Max Button
			var button_max = document.createElement('div');
			button_max.setAttribute('id','max' + windowID);

			if (bmax==true) {
				button_max.setAttribute('class','max');
			} else {
				button_max.setAttribute('class','max-disabled');
			}

			xwindow.appendChild(button_max);

			//Close Button
			var button_close = document.createElement('div');
			button_close.setAttribute('id','close' + windowID);

			if (bclose==true) {
				button_close.setAttribute('class','close');
			} else {
				button_close.setAttribute('class','close-disabled');
			}

			xwindow.appendChild(button_close);

			xwindow.style.position = 'absolute';

			//Class und id setzen
			xwindow.setAttribute('class','xwindow');
			xwindow.setAttribute('id',windowID);

			//Breite und Höhe angeben
			xwindow.style.width = iWidth + 'px';
			xwindow.style.height = iHeight +'px';

			//Position festlegen
			xwindow.style.left = iLeft + 'px';
			xwindow.style.top = iTop + 'px';

			//Fenster ganz nach oben hollen
			xwindow.style.zIndex=ganzoben;
			ganzoben++;

			table.setAttribute('class','xwindow');

			//Erstellen
			xwindow4.appendChild(iframe);

			td[3].appendChild(xwindow3);
			td[4].appendChild(xwindow4);
			td[5].appendChild(xwindow5);
			td[6].appendChild(xwindow6);
			td[7].appendChild(xwindow7);
			td[8].appendChild(xwindow8);

			titelbar.appendChild(textnode);

			td[1].appendChild(titelbar);

			//tr
			for(i=0 ; i<3 ; i++) {
				tbody.appendChild(tr[i]);
			}

			//td
			for(i=0 ; i<3 ; i++) {
				tr[0].appendChild(td[i]);
			}

			for(i=3 ; i<6 ; i++) {
				tr[1].appendChild(td[i]);
			}

			for(i=6 ; i<9 ; i++) {
				tr[2].appendChild(td[i]);
			}

			table.appendChild(tbody);
			xwindow.appendChild(table);
			desktop.appendChild(xwindow);

			window_task_id[windowID] = taskID;

			window_left[windowID] = iLeft;
			window_top[windowID] = iTop;

			window_height[windowID] = iHeight;
			window_width[windowID] = iWidth;

			window_max[windowID] = false;
			window_min[windowID] = false;

			window_move[windowID] = bmove;
			window_resize[windowID] = bresize;

			window_caption[windowID] = sCaption;
			window_icon[windowID] = sIcon;

			window_virt_desk[windowID] = 1;

			//Windows position überprüfen.
			WID = windowID;
			active_window = windowID;

			bwindow_create=true;

			//Fenster position überprüfen
			window_manager.check.window_position();

			//Taskicon erstellen
			taskbar.taskicon.create(sIcon, sName);

			if(gui.xwindow.fade_in!='no') {
				effects.fade.fade_in(windowID, 0, gui.xwindow.opacity, gui.xwindow.fade_in.step, gui.xwindow.fade_in.speed);
			}

			if(gui.xwindow.opacity!='no') {
				effects.opacity(windowID, gui.xwindow.opacity);
			}

			if(gui.xwindow.inaktiv.opacity!=false) {
				for(i=0; i<windowID+1; i++) {
					if(i==WID) {
						effects.opacity(i, 100);
					} else {
						effects.opacity(i, gui.xwindow.opacity);
					}
				}
			}

		}

		//====================================================================================================
		// Window - Remove
		//====================================================================================================
		function remove(KillID) {
			//Überprüfen ob das Fenster vorhanden ist
			if (document.getElementById(KillID)) {
				document.getElementById('desktop').removeChild(document.getElementById(KillID));
				taskbar.taskicon.remove(KillID);
			} else {
				alert('WARNUNG! Das Fenster mit der ID ' + KillID + ' konnte nicht beendet werden, da kein Fenster mit dieser ID vorhanden ist!');
			}

		}

		//====================================================================================================
		// Window - Move
		//====================================================================================================
		function move() {

			this.move = move;
			this.start = start;

			//====================================================================================================
			// Window - Move - Move
			//====================================================================================================
			function move(e) {
				var windowX;
				var windowY;

				if(document.getElementById(objectID).getAttribute('class')=='titelbar') {

					//Kein Internet Explorer
					if(!document.all) {
						event=e;
					}

					windowX=window.event.pageX-window_startX; //horizontal
					windowY=window.event.pageY-window_startY; //vertical

					//umwandeln in eine Zahl
					window_Xalt=parseInt(window_Xalt);
					window_Yalt=parseInt(window_Yalt);

					document.getElementById(WID).style.left=window_Xalt+windowX;
					document.getElementById(WID).style.top=window_Yalt+windowY;

					window_manager.check.window_position();
				}
			}


			//====================================================================================================
			// Window - Move - Start
			//====================================================================================================
			function start(e) {

				//Wenn das Objekt ein Fenster ist
				if(document.getElementById(objectID).getAttribute('class')=='titelbar') {

					if(window_max[WID]==false) {

						iframe_hide(true);

						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						//Fenster ID über die titelbar auslesen.
						WID  = document.getElementById(objectID).parentNode.parentNode.parentNode.parentNode.parentNode.id;

						window_startX=event.pageX;
						window_startY=event.pageY;

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_Xalt=document.getElementById(WID).style.left;
						window_Yalt=document.getElementById(WID).style.top;

						bwindow_move = true;

						//Maus wird bewegt und linke Maustaste ist gedrückt
						document.onmousemove=window_manager.xwindow.move.move; // windowmanager
					}
				}
			}

		}

		//====================================================================================================
		// Window - Resize
		//====================================================================================================
		function resize() {
			this.start = start;
			this.resize = resize;

			//====================================================================================================
			// Window - Resize - Start
			//====================================================================================================
			function start(e) {

				//Wenn das Objekt ein Fenster ist
				switch (document.getElementById(objectID).getAttribute('class')) {
 					 case 'xwindow3':

						window_manager.iframe_hide(true);

						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						//Fenster ID über die titelbar auslesen.
						WID  = document.getElementById(objectID).parentNode.parentNode.parentNode.parentNode.parentNode.id;

						window_startX=event.pageX;

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_width_alt=document.getElementById(WID).style.width;

						window_left_alt = document.getElementById(WID).style.left;

						bwindow_resize = true;

						//Maus wird bewegt und linke Maustaste ist gedrückt
						document.onmousemove=window_manager.xwindow.resize.resize; // windowmanager
						break;

 		 			case 'xwindow5':

						window_manager.iframe_hide(true);

						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						//Fenster ID über die titelbar auslesen.
						WID  = document.getElementById(objectID).parentNode.parentNode.parentNode.parentNode.parentNode.id;

						window_startX=event.pageX;

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_width_alt=document.getElementById(WID).style.width;

						window_left_alt = document.getElementById(WID).style.left;

						bwindow_resize = true;

						//Maus wird bewegt und linke Maustaste ist gedrückt
						document.onmousemove=window_manager.xwindow.resize.resize; // windowmanager
						break;

					case 'xwindow6':

						window_manager.iframe_hide(true);

						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						//Fenster ID über die titelbar auslesen.
						WID  = document.getElementById(objectID).parentNode.parentNode.parentNode.parentNode.parentNode.id;

						window_startX=event.pageX;
						window_startY=event.pageY;

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_width_alt=document.getElementById(WID).style.width;
						window_height_alt=document.getElementById(WID).style.height;

						window_left_alt = document.getElementById(WID).style.left;

						bwindow_resize = true;

						//Maus wird bewegt und linke Maustaste ist gedrückt
						document.onmousemove=window_manager.xwindow.resize.resize; // windowmanager
						break;

 					 case 'xwindow7':

						window_manager.iframe_hide(true);

						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						//Fenster ID über die titelbar auslesen.
						WID  = document.getElementById(objectID).parentNode.parentNode.parentNode.parentNode.parentNode.id;

						window_startY=event.pageY;

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_height_alt=document.getElementById(WID).style.height;

						bwindow_resize = true;

						//Maus wird bewegt und linke Maustaste ist gedrückt
						document.onmousemove=window_manager.xwindow.resize.resize; // windowmanager
						break;

 					 case 'xwindow8':

						window_manager.iframe_hide(true);

						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						window_manager.iframe_hide(true);

						//Fenster ID über die titelbar auslesen.
						WID  = document.getElementById(objectID).parentNode.parentNode.parentNode.parentNode.parentNode.id;

						window_startX=event.pageX;
						window_startY=event.pageY;

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_width_alt=document.getElementById(WID).style.width;
						window_height_alt=document.getElementById(WID).style.height;

						bwindow_resize = true;

						//Maus wird bewegt und linke Maustaste ist gedrückt
						document.onmousemove=window_manager.xwindow.resize.resize; // windowmanager
						break;

				}
			
			}

			//====================================================================================================
			// Window - Resize - Resize
			//====================================================================================================
			function resize(e) {

				var windowX;
				var windowY;

				switch (document.getElementById(objectID).getAttribute('class')) {
 		 			case 'xwindow3':
						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						windowX=event.pageX-window_startX; //vertical

						//umwandeln in eine Zahl
						window_width_alt=parseInt(window_width_alt);

						//umwandeln in eine Zahl
						window_left_alt=parseInt(window_left_alt);

						document.getElementById(WID).style.left=window_left_alt+windowX;
						document.getElementById(WID).style.width=window_width_alt-windowX;

						window_manager.check.window_position();

    						break;

 		 			case 'xwindow5':
						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						windowX=event.pageX-window_startX; //vertical

						//umwandeln in eine Zahl
						window_width_alt=parseInt(window_width_alt);

						document.getElementById(WID).style.width=window_width_alt+windowX;

						window_manager.check.window_position();

						break;

		 			case 'xwindow6':
						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						windowX=event.pageX-window_startX; //horizontal
						windowY=event.pageY-window_startY; //vertical

						//umwandeln in eine Zahl
						window_width_alt=parseInt(window_width_alt);
						window_height_alt=parseInt(window_height_alt);

						//umwandeln in eine Zahl
						window_left_alt=parseInt(window_left_alt);

						document.getElementById(WID).style.left=window_left_alt+windowX;

						document.getElementById(WID).style.width=window_width_alt-windowX;
						document.getElementById(WID).style.height=window_height_alt+windowY;

						window_manager.check.window_position();

    						break;

		 			case 'xwindow7':
						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						windowY=event.pageY-window_startY; //vertical

						//umwandeln in eine Zahl
						window_height_alt=parseInt(window_height_alt);

						document.getElementById(WID).style.height=window_height_alt+windowY;

						window_manager.check.window_position();

    						break;

 		 			case 'xwindow8':
						//Kein Internet Explorer
						if(!document.all) {
							event=e;
						}

						windowX=event.pageX-window_startX; //horizontal
						windowY=event.pageY-window_startY; //vertical

						//umwandeln in eine Zahl
						window_width_alt=parseInt(window_width_alt);
						window_height_alt=parseInt(window_height_alt);

						document.getElementById(WID).style.width=window_width_alt+windowX;
						document.getElementById(WID).style.height=window_height_alt+windowY;

						window_manager.check.window_position();

    						break;

				}

			}

		}

		//====================================================================================================
		// Window - Activate
		//====================================================================================================
		function activate(e) {

			//Kein Internet Explorer
			if(!document.all) {
				event=e;
			}

			document.getElementById(WID).style.zIndex=ganzoben;
			ganzoben++;

			if(top.gui.xwindow.inaktiv.opacity!=false) {
				for(i=0; i<windowID+1; i++) {
					if(i==WID) {
						effects.opacity(i, 100);
					} else {
						effects.opacity(i, top.gui.xwindow.opacity);
					}
				}
			}

		}

		//====================================================================================================
		// Window - Check
		//====================================================================================================
		function check() {
			//this.close_click = window_manager.check.close_click;
			//this.max_click = window_manager.check.max_click;
			//this.min_click = window_manager.check.min_click;

			//this.position = window_manager.check.window_position;
			//this.size = window_manager.check.window_size;
			//this.position_and_size = window_manager.check.window_position_and_size;
		}

	}

	//====================================================================================================
	// Mouse
	//====================================================================================================
	function mouse() {
		this.click_down = click_down;
		this.click_up = click_up;

		//====================================================================================================
		// Mouse - Click_Down
		//====================================================================================================
		function click_down(e) {

			//Exestiert das Object überhaupt?
			if(document.getElementById(objectID)) {

				if(document.getElementById(objectID).getAttribute('class')=='xwindow0' || document.getElementById(objectID).getAttribute('class')=='xwindow1' || document.getElementById(objectID).getAttribute('class')=='xwindow2' || document.getElementById(objectID).getAttribute('class')=='xwindow3' || document.getElementById(objectID).getAttribute('class')=='xwindow4' || document.getElementById(objectID).getAttribute('class')=='xwindow5' || document.getElementById(objectID).getAttribute('class')=='xwindow6' || document.getElementById(objectID).getAttribute('class')=='xwindow7' || document.getElementById(objectID).getAttribute('class')=='xwindow8' || document.getElementById(objectID).getAttribute('class')=='titelbar') {

					//Fenster ID über die titelbar auslesen.
					WID  = document.getElementById(objectID).parentNode.parentNode.parentNode.parentNode.parentNode.id;

					active_window = WID;

					//Wenn das Fenster nicht maximiert ist
					if(window_max[WID]==false) {

						//Wenn das Fenster bewegt werden darf
						if(window_move[WID]==true) {
							window_manager.xwindow.move.start(e);
						}
			
						//Wenn die größe des Fensters verändert werden darf
						if(window_resize[WID]==true) {
							window_manager.xwindow.resize.start(e);
						}
					}

					if(gui.xwindow.inaktiv.opacity!=false) {
						for(i=0; i<windowID+1; i++) {
							if(i==WID) {
								effects.opacity(i, 100);
							} else {
								effects.opacity(i, gui.xwindow.opacity);
							}
						}
					}
				}

				//activateWindow(e);
				window_manager.check.close_click(e);
				window_manager.check.max_click(e);
				window_manager.check.min_click(e);

			}

		}	

		//====================================================================================================
		// Mouse - Click_Up
		//====================================================================================================
		function click_up() {

			if(bwindow_move==true || bwindow_resize==true) {
				iframe_hide(false);
			}

			bwindow_move = false;
			bwindow_resize = false;

			document.onmousemove=none;
		}
	}

	//====================================================================================================
	// Check
	//====================================================================================================
	function check() {
		this.close_click = close_click;
		this.max_click = max_click;
		this.min_click = min_click;

		this.window_position = window_position;
		this.window_size = window_size;
		//this.window_position_and_size = window_position_and_size;

		//====================================================================================================
		// Check - Close_Click
		//====================================================================================================
		function close_click() {
			var KillID;

			if(document.getElementById(objectID).getAttribute('class')=='close') {

				//Fenster ID über die titelbar auslesen.
				KillID  = document.getElementById(objectID).parentNode.id;
				taskmanager.kill(KillID);
			}
		}

		//====================================================================================================
		// Check - Max_Click
		//====================================================================================================
		function max_click() {

			if(document.getElementById(objectID).getAttribute('class')=='max') {
				WID  = document.getElementById(objectID).parentNode.id;

				switch (window_max[WID]) {
 					case false: //max

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_left[WID] = document.getElementById(WID).style.left;
						window_top[WID] = document.getElementById(WID).style.top;

						window_width[WID] = document.getElementById(WID).style.width;
						window_height[WID] = document.getElementById(WID).style.height;

						document.getElementById(WID).style.left=0;
						document.getElementById(WID).style.top=taskbar_height;

						gui.desktop.width = parseInt(gui.desktop.width);
						gui.desktop.height = parseInt(gui.desktop.height);

						panel_height = parseInt(panel_height);
						taskbar_height = parseInt(taskbar_height);

						document.getElementById(WID).style.width=gui.desktop.width;
						document.getElementById(WID).style.height=gui.desktop.height - 32 - panel_height;

						window_max[WID] = true;

						bwindow_move = false;
						bwindow_resize = false;

						break;
					case true: //normal

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						document.getElementById(WID).style.left=window_left[WID];
						document.getElementById(WID).style.top=window_top[WID];

						document.getElementById(WID).style.width=window_width[WID];
						document.getElementById(WID).style.height=window_height[WID];

						window_max[WID] = false;

						break;
				}

				window_manager.xwindow.activate();
			}
		}

		//====================================================================================================
		// Check - Min-Click
		//====================================================================================================
		function min_click() {
			if(document.getElementById(objectID).getAttribute('class')=='min') {
				WID  = document.getElementById(objectID).parentNode.id;

				switch (window_min[WID]) {
 					case false: //min

						document.getElementById(WID).style.display='none';

						window_min[WID] = true;

						break;
					case true: //normal

						document.getElementById(WID).style.display='inline';

						document.getElementById(WID).style.zIndex=ganzoben;
						ganzoben++;

						window_min[WID] = false;

						break;
				}
			}

		}

		//====================================================================================================
		// Check - Window_Position
		//====================================================================================================
		function window_position() {

			var xwindow_width;
			var xwindow_height;

			var xwindow_left;
			var xwindow_top;

			//Taskbar
			var taskbar_border_left;
			var taskbar_border_right;
	
			var taskbar_border_top;
			var taskbar_border_bottom;

			//Panel
			var panel_border_left;
			var panel_border_right;
	
			var panel_border_top;
			var panel_border_bottom;

			xwindow_left = parseInt(document.getElementById(WID).style.left);
			xwindow_top = parseInt(document.getElementById(WID).style.top);

			xwindow_width = parseInt(document.getElementById(WID).style.width);
			xwindow_height = parseInt(document.getElementById(WID).style.height);

			//Border/Rahmen der Taskleiste
			taskbar_border_left = parseInt(document.getElementById('taskbar').style.borderLeft);
			taskbar_border_right = parseInt(document.getElementById('taskbar').style.borderRight);

			taskbar_border_top = parseInt(document.getElementById('taskbar').style.borderTop);
			taskbar_border_bottom = parseInt(document.getElementById('taskbar').style.borderBottom);

			//Border/Rahmen des Panels
			panel_border_left = parseInt(document.getElementById('panel').style.borderLeft);
			panel_border_right = parseInt(document.getElementById('panel').style.borderRight);

			panel_border_top = parseInt(document.getElementById('panel').style.borderTop);
			panel_border_bottom = parseInt(document.getElementById('panel').style.borderBottom);

			//Taskbar
			if(isNaN(taskbar_border_left)){
				taskbar_border_left=0;
			}

			if(isNaN(taskbar_border_right)){
				taskbar_border_right=0;
			}

			if(isNaN(taskbar_border_top)){
				taskbar_border_top=0;
			}

			if(isNaN(taskbar_border_bottom)){
				taskbar_border_bottom=0;
			}

			//Panel
			if(isNaN(panel_border_left)){
				panel_border_left=0;
			}

			if(isNaN(panel_border_right)){
				panel_border_right=0;
			}

			if(isNaN(panel_border_top)){
				panel_border_top=0;
			}

			if(isNaN(panel_border_bottom)){
				panel_border_bottom=0;
			}

			//Wenn das Fenster erstellt wurde
			if (bwindow_create==true) {
				if (xwindow_left < 0) {
					document.getElementById(WID).style.left=0;
				}

				if (xwindow_top < 32 + taskbar_border_top) {
					document.getElementById(WID).style.top=32 + taskbar_border_top;
				}

				if (xwindow_left + xwindow_width > gui.desktop.width) {
					document.getElementById(WID).style.left=gui.desktop.width - xwindow_width;
				}

				if (xwindow_top + xwindow_height > gui.desktop.height + panel_border_top + taskbar_border_bottom) {
					document.getElementById(WID).style.top=gui.desktop.height - xwindow_height - panel_border_top - panel_border_bottom;
				}

				//Damit das Fenster nicht zu klein gemacht werden kann
				if (xwindow_width<200) {
					document.getElementById(WID).style.width=200;
				}

				if (xwindow_height<100) {
					document.getElementById(WID).style.height=100;
				}

				bwindow_create = false;
			}

			//Wenn das Fenster bewegt wurde
			if (bwindow_move==true) {
				if (xwindow_left < 0) {
					document.getElementById(WID).style.left=0;
				}

				if (xwindow_top < 32 + taskbar_border_top) {
					document.getElementById(WID).style.top=32 + taskbar_border_top;
				}

				if (xwindow_left + xwindow_width > gui.desktop.width) {
					document.getElementById(WID).style.left=gui.desktop.width - xwindow_width;
				}

				if ( xwindow_top + xwindow_height > gui.desktop.height - panel_height) {
					document.getElementById(WID).style.top=gui.desktop.height - xwindow_height - panel_height - panel_border_top - panel_border_bottom;
				}
			}

			if (bwindow_resize==true) {

				if (xwindow_left<0) {
					document.getElementById(WID).style.left=0;
				}


				if (xwindow_top<0) {
					document.getElementById(WID).style.top=0;
				}

				//Damit das Fenster nicht zu klein gemacht werden kann
				if (xwindow_width<200) {
					document.getElementById(WID).style.width=200;
				}

				if (xwindow_height<100) {
					document.getElementById(WID).style.height=100;
				}

				//Wenn es größer als der Desktop ist
				if (xwindow_width>gui.desktop.width) {
					document.getElementById(WID).style.width=gui.desktop.width;
					document.getElementById(WID).style.left=0;
				}

				if (xwindow_height>gui.desktop.height - 64) {
					document.getElementById(WID).style.height=gui.desktop.height - 64;
					document.getElementById(WID).style.top=32;
				}

				//Position
				if (xwindow_left < 0) {
					document.getElementById(WID).style.left=0;
				}

				if (xwindow_top < 32 + taskbar_border_top) {
					document.getElementById(WID).style.top=32 + taskbar_border_top;
				}

				if (xwindow_left + xwindow_width > gui.desktop.width) {
					document.getElementById(WID).style.left=gui.desktop.width - xwindow_width;
				}

				if ( xwindow_top + xwindow_height > gui.desktop.height - panel_height) {
					document.getElementById(WID).style.top=gui.desktop.height - xwindow_height - panel_height - panel_border_top - panel_border_bottom;
				}


			}
		}

		//====================================================================================================
		// Check - Window_Size
		//====================================================================================================
		function window_size() {

			var xwindow_width;
			var xwindow_height;

			//Taskbar
			var taskbar_border_left;
			var taskbar_border_right;
	
			var taskbar_border_top;
			var taskbar_border_bottom;

			//Panel
			var panel_border_left;
			var panel_border_right;
	
			var panel_border_top;
			var panel_border_bottom;

			xwindow_width = parseInt(document.getElementById(WID).style.width);
			xwindow_height = parseInt(document.getElementById(WID).style.height);


			//Wenn das Fenster erstellt wurde
			if (bwindow_create==true) {

				//Damit das Fenster nicht zu klein gemacht werden kann
				if (xwindow_width<200) {
					document.getElementById(WID).style.width=200;
				}

				if (xwindow_height<100) {
					document.getElementById(WID).style.height=100;
				}

				bwindow_create = false;
			}

			//Wenn die Fenster größe verändert wurde
			if (bwindow_resize==true) {

				//Damit das Fenster nicht zu klein gemacht werden kann
				if (xwindow_width<200) {
					document.getElementById(WID).style.width=200;
				}

				if (xwindow_height<100) {
					document.getElementById(WID).style.height=100;
				}

				//Wenn es größer als der Desktop ist
				if (xwindow_width>gui.desktop.width) {
					document.getElementById(WID).style.width=gui.desktop.width;
					document.getElementById(WID).style.left=0;
				}

				if (xwindow_height>gui.desktop.height - 64) {
					document.getElementById(WID).style.height=gui.desktop.height - 64;
					document.getElementById(WID).style.top=32;
				}

			}
		}

	}

	//====================================================================================================
	// iFrame_Hide
	//====================================================================================================
	function iframe_hide(bhide) {

		var i = 1;

		switch (bhide) {
			case true:
				for(i=1 ; i<windowID + 1 ; i++) {
					if(document.getElementById('xwindow4_' + i)){
						document.getElementById('xwindow4_' + i).style.display='none';
						//document.getElementById('xwindow4_' + i).style.visibility = 'hidden';
					}
				}
			
				break;

			case false:
				for(i=1 ; i<windowID + 1 ; i++) {
					if(document.getElementById('xwindow4_' + i)){
						document.getElementById('xwindow4_' + i).style.display='inline';
						//document.getElementById('xwindow4_' + i).style.visibility = 'visible';
					}
				}

				break;

		}

	}

}